---
title: 'ARIA: figure role'
slug: Web/Accessibility/ARIA/Roles/Figure_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA figure
  - Accessibility
  - Reference
  - Rôle
  - figure
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>The ARIA <code>figure</code> role can be used to identify a figure inside page content where appropriate semantics do not already exist. A figure is generally considered to be one or more images, code snippets, or other content that puts across information in a different way to a regular flow of text.</p>

<pre class="brush: html">&lt;div role="figure" aria-labelledby="caption"&gt;
  &lt;img src="image.png"
      alt="full alternative image description"&gt;
  &lt;p id="caption"&gt;Figure 1: The caption&lt;/p&gt;
&lt;/div&gt;
</pre>

<p>In the above example, we have a figure that consists of two separate content items — an image and a caption. This is wrapped by a {{htmlelement("div")}} element that identifies the content as a figure using <code>role="figure"</code>.</p>

<p>Instead of using ARIA to create a figure, consider using the native, semantic <a href="/en-US/docs/Web/HTML/Element/figure">HTML &lt;figure&gt; element</a>. along with the <a href="/en-US/docs/Web/HTML/Element/figcaption">&lt;figcaption&gt; element</a>.  See {{anch("Best practices")}} below.</p>

<h2 id="Description">Description</h2>

<p>Any content that should be grouped together and consumed as a figure (which could include images, video, audio, code snippets, or other content) can be identified as a figure using <code>role="figure"</code>.</p>

<p>There are no hard and fast rules about how you should write your figure content. You should make sure that it is accessible just like any other content. For example, make sure it is perceivable by users of assistive technology, navigable by keyboard as well as mouse, and so on.</p>

<p>You can add a caption or label to your figure in a number of ways. You could add an ID to an element containing content that describes the figure, and then reference that ID inside an appropriate attribute on the figure to associate the figure with the label:</p>

<pre class="brush: html">&lt;div role="figure" aria-labelledby="figure-1"&gt;
  ...
  &lt;p id="figure-1"&gt;Text that describes the figure.&lt;/p&gt;
&lt;/div&gt;</pre>

<ul>
 <li>Use <code>aria-labelledby</code> when the text is a concise label.</li>
 <li>Use <code>aria-describedby</code> when the text is a longer description.</li>
</ul>

<p>Again, this can be done semantically, without ARIA, with HTML's <code><a href="/en-US/docs/Web/HTML/Element/figure">&lt;figure&gt;</a></code> and <code><a href="/en-US/docs/Web/HTML/Element/figcaption">&lt;figcaption&gt;</a></code> elements</p>

<pre class="brush: html">&lt;figure&gt;
  ...
  &lt;figcaption&gt;Text that describes the figure.&lt;/figcaption&gt;
&lt;/figure&gt;</pre>

<ul>
</ul>

<p>If you don't want the label to be visible on the screen, but still want to provide a descriptive label for assistive technology users, you can use the <code>aria-label</code> attribute on the figure container:</p>

<pre class="brush: html">&lt;div role="figure" aria-label="Text that describes the figure."&gt;
  ...
&lt;/div&gt;</pre>

<p>You can use the aria-label with &lt;figure&gt; as well:</p>

<pre class="brush: html">&lt;figure aria-label="Text that describes the figure."&gt;
  ...
&lt;/figure&gt;</pre>

<p>Generally, you should reference the figure from the main text, but the figure need not be displayed at the same location as the referencing element.</p>

<div class="note">
<p><strong>Note</strong>:<span class="ILfuVd yZ8quc"> If at all possible in your work, you should use the appropriate semantic HTML elements to mark up a figure and its caption — {{htmlelement("figure")}} and {{htmlelement("figcaption")}}. See {{anch("Best practices")}} for a full example.</span></p>
</div>


<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<dl>
 <dt>aria-describedby</dt>
 <dd>The id of an element containing reference text serving as a caption.</dd>
 <dt>aria-labelledby</dt>
 <dd>The id of an element containing text serving as a label.</dd>
 <dt>aria-label</dt>
 <dd>If there is no element containing text that could serve as a label, you can add the label directly as a value on the aria-label on the element with the <code>figure</code> role or on the <code>&lt;figure&gt;</code> element.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>No role specific keyboard interactions.</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>No role specific JavaScript requirements. If you don't have control over the HTML semantics, you can improve the accessibility of HTML by adding these roles and properties with JavaScript.</p>

<h2 id="Examples">Examples</h2>

<p>We could extend the initial example on the page to also identify a paragraph that provides a descriptive label for the figure by referencing its ID in <code>aria-labelledby</code>:</p>

<pre>&lt;div role="figure" aria-labelledby="figure-1"&gt;
  &lt;img src="diagram.png"
       alt="diagram showing the four layers of awesome and their relative priority order —
            music, cats, nature, and ice cream"&gt;
  &lt;pre&gt;&lt;code&gt;
    let awesome = ['music', 'cats', 'nature', 'ice cream'];
  &lt;/code&gt;&lt;/pre&gt;
  &lt;p id="figure-1"&gt;Figure 1: The four layers of awesome.&lt;/p&gt;
&lt;/div&gt;</pre>

<h2 id="Best_practices">Best practices</h2>

<p>Only use <code>role="figure"</code> if you have to — for example if you don't have control over your HTML but are able to improve accessibility dynamically after the fact with JavaScript.</p>

<p>If at all possible, you<span class="ILfuVd yZ8quc"> should use the appropriate semantic HTML elements to mark up a figure and its caption — {{htmlelement("figure")}} and {{htmlelement("figcaption")}}. For example, our above example should be rewritten as follows:</span></p>

<pre class="brush: html">&lt;figure&gt;
  &lt;img src="diagram.png"
       alt="diagram showing the four layers of awesome and their relative priority order —
       music, cats, nature, and ice cream"&gt;
  &lt;pre&gt;&lt;code&gt;
    let awesome = ['music', 'cats', 'nature', 'ice cream'];
  &lt;/code&gt;&lt;/pre&gt;
  &lt;figcaption&gt;Figure 1: The four layers of awesome.&lt;/figcaption&gt;
&lt;/figure&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#figure","figure")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://wicg.github.io/aom/spec/">Accessibility Object Model</a></li>
 <li><a href="https://w3c.github.io/html-aria/">ARIA in HTML</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/figure">HTML &lt;figure&gt; element</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/figcaption">HTML &lt;figcaption&gt; element</a></li>
</ul>
